diff --git a/db/migrate/20140219183343_migrate_permissions.rb b/db/migrate/20140219183343_migrate_permissions.rb
new file mode 100644
index 000000000..751fc7c58
--- /dev/null
+++ b/db/migrate/20140219183343_migrate_permissions.rb
@@ -0,0 +1,298 @@
+# we need permissions to be seeded already
+require Rails.root + 'db/seeds.d/20-permissions'
+
+# Fake models to make sure that this migration can be executed even when
+# original models changes later (e.g. add validation on columns that are not
+# present at this moment)
+class FakePermission < ActiveRecord::Base
+  set_table_name 'permissions'
+end
+
+class FakeFilter < ActiveRecord::Base
+  set_table_name 'filters'
+  # we need this for polymorphic relation to work, it has class name hardcoded in AR
+  def self.name
+    'Filter'
+  end
+  belongs_to :role, :class_name => 'FakeRole'
+  has_many :filterings, :dependent => :destroy, :foreign_key => 'filter_id'
+  has_many :permissions, :through => :filterings
+
+  def resource_type
+    @resource_type ||= permissions.first.try(:resource_type)
+  end
+
+  taxonomy_join_table = "taxable_taxonomies"
+  has_many taxonomy_join_table, :dependent => :destroy, :as => :taxable, :foreign_key => 'taxable_id'
+  has_many :locations,     :through => taxonomy_join_table, :source => :taxonomy,
+           :conditions => "taxonomies.type='Location'", :validate => false
+  has_many :organizations, :through => taxonomy_join_table, :source => :taxonomy,
+           :conditions => "taxonomies.type='Organization'", :validate => false
+
+end
+
+class FakeUserRole < ActiveRecord::Base
+  set_table_name 'user_roles'
+  belongs_to :owner, :polymorphic => true
+  belongs_to :role, :class_name => 'FakeRole'
+end
+
+class FakeRole < ActiveRecord::Base
+  set_table_name 'roles'
+  scope :builtin, lambda { |*args|
+    compare = 'not' if args.first
+    where("#{compare} builtin = 0")
+  }
+
+  has_many :filters, :dependent => :destroy, :class_name => 'FakeFilter', :foreign_key => 'role_id'
+  has_many :permissions, :through => :filters, :class_name => 'FakePermission', :foreign_key => 'permission_id'
+end
+
+class FakeFiltering < ActiveRecord::Base
+  set_table_name 'filterings'
+  belongs_to :filter, :class_name => 'FakeFilter'
+  belongs_to :permission, :class_name => 'FakePermission'
+end
+
+class FakeUser < ActiveRecord::Base
+  set_table_name 'users'
+  # we need this for polymorphic relation to work, it has class name hardcoded in AR
+  def self.name
+    'User'
+  end
+
+  has_and_belongs_to_many :compute_resources, :join_table => "user_compute_resources", :foreign_key => 'user_id'
+  has_and_belongs_to_many :domains, :join_table => "user_domains", :foreign_key => 'user_id'
+  has_many :user_hostgroups, :dependent => :destroy, :foreign_key => 'user_id'
+  has_many :hostgroups, :through => :user_hostgroups
+  has_many :user_facts, :dependent => :destroy, :foreign_key => 'user_id'
+  has_many :facts, :through => :user_facts, :source => :fact_name
+  has_many :user_roles, :dependent => :destroy, :foreign_key => 'owner_id',
+           :conditions => {:owner_type => 'User'}, :class_name => 'FakeUserRole'
+  has_many :roles, :through => :user_roles, :dependent => :destroy, :class_name => 'FakeRole'
+  taxonomy_join_table = "taxable_taxonomies"
+  has_many taxonomy_join_table, :dependent => :destroy, :as => :taxable, :foreign_key => 'taxable_id'
+  has_many :locations,     :through => taxonomy_join_table, :source => :taxonomy,
+           :conditions => "taxonomies.type='Location'", :validate => false
+  has_many :organizations, :through => taxonomy_join_table, :source => :taxonomy,
+           :conditions => "taxonomies.type='Organization'", :validate => false
+  has_many :cached_usergroup_members, :foreign_key => 'user_id'
+  has_many :cached_usergroups, :through => :cached_usergroup_members, :source => :usergroup
+end
+
+class MigratePermissions < ActiveRecord::Migration
+  def self.up
+    if old_permissions_present
+      migrate_roles
+      migrate_user_filters
+
+      flag = Setting::General.find_or_initialize_by_name('fix_db_cache',
+                                                         :description   => 'Fix DB cache on next Foreman restart',
+                                                         :settings_type => 'boolean', :default => false)
+      flag.update_attributes :value => true
+      Rake::Task['db:migrate'].enhance nil do
+        Rake::Task['fix_db_cache'].invoke
+      end
+    else
+      say 'Skipping migration of permissions, since old permissions are not present'
+    end
+  end
+
+  # STEP 1 - migrate roles
+  # for all role permissions we'll create unlimited filters
+  # we'll group permissions into filters by their resource
+  def self.migrate_roles
+    roles = FakeRole.all
+    roles.each do |role|
+
+      # role without permissions? nothing to do then
+      if role.attributes['permissions'].nil?
+        say "no old permissions found for role '#{role.name}', skipping"
+        next
+      end
+
+      # permissions assigned to role which we want to migrate
+      permission_names = YAML.load(role.attributes['permissions'])
+
+      # role without permissions but with YAML record
+      if permission_names.blank?
+        clear_old_permission(role)
+        next
+      end
+
+      # filter out unknown permissions, this could be leftovers from an old plugin.
+      role_permissions = FakePermission.where(:name => permission_names)
+
+      # we group permissions by resource the belong to
+      # then create a filter per resource
+      # and create a new relation between mapped permission and this filter
+      role_permissions.group_by(&:resource_type).each do |resource, permissions|
+        filter = FakeFilter.new
+        filter.role = role
+        filter.save!
+        say "Created an unlimited filter for role '#{role.name}'"
+
+        permissions.each do |permission|
+          filtering            = FakeFiltering.new
+          filtering.filter     = filter
+          filtering.permission = FakePermission.find_by_name(permission.name)
+          filtering.save!
+          say "... with permission '#{permission.name}'"
+        end
+      end
+
+      # finally we clear old permissions from role so
+      clear_old_permission(role)
+    end
+  end
+
+  def self.clear_old_permission(role)
+    say "Clearing old permissions for role '#{role.name}'"
+    if FakeRole.update_all("permissions = NULL", "id = #{role.id}") == 1
+      say "... OK"
+    else
+      raise "could not clear old permissions for role '#{role.name}'"
+    end
+  end
+
+  # STEP 2 - migrate user filters
+  # for every user having a filter we make copy of all his roles and add filtering scoped searches
+  # to corresponding filters
+  def self.migrate_user_filters
+    users = FakeUser.all
+    users.each do |user|
+      unless filtered?(user)
+        say "no filters found for user '#{user.login}', skipping"
+        next
+      end
+
+      say "Migrating user '#{user.login}'"
+      say "... cloning all roles"
+      clones     = user.roles.builtin(false).map { |r| clone_role(r, user) }
+      user.roles = clones + user.roles.builtin(true)
+      say "... done"
+
+      filters                     = Hash.new { |h, k| h[k] = '' }
+
+      # compute resources
+      filters[:compute_resources] = search = user.compute_resources.uniq.map { |cr| "id = #{cr.id}" }.join(' or ')
+      affected                    = clones.map(&:filters).flatten.select { |f| f.resource_type == 'ComputeResource' }
+      affected.each do |filter|
+        filter.update_attributes :search => search unless search.blank?
+      end
+      say "... compute resource filters applied"
+
+      # domains were not limited in old system, to keep it compatible, we don't convert it and use just search string
+      # later for hosts
+      filters[:domains]    = user.domains.uniq.map { |cr| "id = #{cr.id}" }.join(' or ')
+
+      # host groups
+      filters[:hostgroups] = search = user.hostgroups.uniq.map { |cr| "id = #{cr.id}" }.join(' or ')
+      affected             = clones.map(&:filters).flatten.select { |f| f.resource_type == 'Hostgroup' }
+      affected.each do |filter|
+        filter.update_attributes :search => search unless search.blank?
+      end
+      say "... hostgroups filters applied"
+
+      # fact_values for hosts scope
+      filters[:facts] = user.user_facts.uniq.map { |uf| "facts.#{uf.fact_name.name} #{uf.operator} #{uf.criteria}" }.join(' or ')
+
+      search, orgs, locs = convert_filters_to_search(filters, user)
+
+      affected = clones.map(&:filters).flatten.select { |f| f.resource_type == 'Host' }
+      affected.each do |filter|
+        filter.organizations = orgs
+        filter.locations = locs
+        filter.update_attributes :search => search unless search.blank?
+      end
+      say "... all other filters applied"
+
+      say "Removing old filter"
+      user.domains           = []
+      user.compute_resources = []
+      user.hostgroups        = []
+      user.facts             = []
+      user.filter_on_owner   = false
+      user.save!
+      say "... done"
+    end
+  end
+
+  def self.convert_filters_to_search(filters, user)
+    search = ''
+    orgs = []
+    locs = []
+
+    # owner_type
+    if user.filter_on_owner
+      user_cond = "owner_id = #{user.id} and owner_type = User"
+      group_cond = user.cached_usergroups.uniq.map { |g| "owner_id = #{g.id}" }.join(' or ')
+      search = "(#{user_cond})"
+      search += " or ((#{group_cond}) and owner_type = Usergroup)" unless group_cond.blank?
+    end
+
+    # normal filters - domains, compute resource, hostgroup, facts
+    filter = filters[:domains].gsub('id', 'domain_id')
+    search = "(#{search}) #{user.domains_andor} (#{filter})" unless filter.blank?
+    filter = filters[:compute_resources].gsub('id', 'compute_resource_id')
+    search = "(#{search}) #{user.compute_resources_andor} (#{filter})" unless filter.blank?
+    filter = filters[:hostgroups].gsub('id', 'hostgroup_id')
+    search = "(#{search}) #{user.hostgroups_andor} (#{filter})" unless filter.blank?
+    filter = filters[:facts]
+    search = "(#{search}) #{user.facts_andor} (#{filter})" unless filter.blank?
+
+    # taxonomies
+    if SETTINGS[:organizations_enabled]
+      orgs = user.organizations
+    end
+    if SETTINGS[:locations_enabled]
+      locs = user.locations
+    end
+
+    # fix first and/or that could appear
+    search = search.sub(/^\(\)\s*(and|or)\s*/, '')
+    [ search, orgs, locs ]
+  end
+
+  def self.filtered?(user)
+    user.compute_resources.present? ||
+        user.domains.present? ||
+        user.hostgroups.present? ||
+        user.facts.present? ||
+        user.filter_on_owner
+  end
+
+  def self.clone_role(role, user)
+    clone      = role.dup
+    clone.name = role.name + "_#{user.login}"
+    clone.save!
+
+    role.filters.each { |f| clone_filter(f, clone) }
+
+    clone.reload
+  end
+
+  def self.clone_filter(filter, role)
+    clone             = filter.dup
+    clone.permissions = filter.permissions
+    clone.role        = role
+    clone.save!
+  end
+
+
+  # To detect whether migration is needed we use existing models
+  # fakes would always indicate that migration is needed
+  def self.old_permissions_present
+    user = User.new
+    Role.column_names.include?('permissions') &&
+        user.respond_to?(:compute_resources) &&
+        user.respond_to?(:domains) &&
+        user.respond_to?(:hostgroups) &&
+        user.respond_to?(:facts) &&
+        user.respond_to?(:filter_on_owner)
+  end
+
+  def self.down
+    say 'Permission data migration is impossible, skipping'
+  end
+end
diff --git a/db/migrate/20140219183345_add_taxonomy_searches_to_filter.rb b/db/migrate/20140219183345_add_taxonomy_searches_to_filter.rb
new file mode 100644
index 000000000..04d4720db
--- /dev/null
+++ b/db/migrate/20140219183345_add_taxonomy_searches_to_filter.rb
@@ -0,0 +1,21 @@
+class AddTaxonomySearchesToFilter < ActiveRecord::Migration
+  def self.up
+    add_column :filters, :taxonomy_search, :text
+
+    # to precache taxonomy search on all existing filters
+    # setting may not exist yet
+    flag = Setting::General.find_or_initialize_by_name('fix_db_cache',
+                                                       :description   => 'Fix DB cache on next Foreman restart',
+                                                       :settings_type => 'boolean', :default => false)
+    flag.update_attributes :value => true
+
+    Rake::Task['db:migrate'].enhance nil do
+      Filter.reset_column_information
+      Rake::Task['fix_db_cache'].invoke
+    end
+  end
+
+  def self.down
+    remove_column :filters, :taxonomy_search
+  end
+end
diff --git a/db/seeds.d/05-architectures.rb b/db/seeds.d/05-architectures.rb
new file mode 100644
index 000000000..03de07692
--- /dev/null
+++ b/db/seeds.d/05-architectures.rb
@@ -0,0 +1,5 @@
+# Architectures
+Architecture.without_auditing do
+  Architecture.find_or_create_by_name "x86_64"
+  Architecture.find_or_create_by_name "i386"
+end
diff --git a/db/seeds.d/07-config_templates.rb b/db/seeds.d/07-config_templates.rb
new file mode 100644
index 000000000..5e74d77f3
--- /dev/null
+++ b/db/seeds.d/07-config_templates.rb
@@ -0,0 +1,59 @@
+# Find known operating systems for associations
+os_junos = Operatingsystem.find_all_by_type "Junos" || Operatingsystem.where("name LIKE ?", "junos")
+os_solaris = Operatingsystem.find_all_by_type "Solaris"
+os_suse = Operatingsystem.find_all_by_type "Suse" || Operatingsystem.where("name LIKE ?", "suse")
+os_windows = Operatingsystem.find_all_by_type "Windows"
+
+# Template kinds
+kinds = {}
+[:PXELinux, :PXEGrub, :iPXE, :provision, :finish, :script, :user_data, :ZTP].each do |type|
+  kinds[type] = TemplateKind.find_by_name(type)
+  kinds[type] ||= TemplateKind.create :name => type
+  raise "Unable to create template kind: #{format_errors kinds[type]}" if kinds[type].nil? || kinds[type].errors.any?
+end
+
+# Provisioning templates
+ConfigTemplate.without_auditing do
+  [
+      # Generic PXE files
+      { :name => 'PXELinux global default', :source => 'pxe/PXELinux_default.erb', :template_kind => kinds[:PXELinux] },
+      { :name => 'PXELinux default local boot', :source => 'pxe/PXELinux_local.erb', :template_kind => kinds[:PXELinux] },
+      { :name => 'PXEGrub default local boot', :source => 'pxe/PXEGrub_local.erb', :template_kind => kinds[:PXEGrub] },
+      # OS specific files
+      { :name => 'AutoYaST default', :source => 'autoyast/provision.erb', :template_kind => kinds[:provision], :operatingsystems => os_suse },
+      { :name => 'AutoYaST SLES default', :source => 'autoyast/provision_sles.erb', :template_kind => kinds[:provision], :operatingsystems => os_suse },
+      { :name => 'AutoYaST default PXELinux', :source => 'autoyast/PXELinux.erb', :template_kind => kinds[:PXELinux], :operatingsystems => os_suse },
+      { :name => 'Grubby default', :source => 'scripts/grubby.erb', :template_kind => kinds[:script] },
+      { :name => 'Jumpstart default', :source => 'jumpstart/provision.erb', :template_kind => kinds[:provision], :operatingsystems => os_solaris },
+      { :name => 'Jumpstart default finish', :source => 'jumpstart/finish.erb', :template_kind => kinds[:finish], :operatingsystems => os_solaris },
+      { :name => 'Jumpstart default PXEGrub', :source => 'jumpstart/PXEGrub.erb', :template_kind => kinds[:PXEGrub], :operatingsystems => os_solaris },
+      { :name => 'Kickstart default', :source => 'kickstart/provision.erb', :template_kind => kinds[:provision] },
+      { :name => 'Kickstart RHEL default', :source => 'kickstart/provision_rhel.erb', :template_kind => kinds[:provision] },
+      { :name => 'Kickstart default PXELinux', :source => 'kickstart/PXELinux.erb', :template_kind => kinds[:PXELinux] },
+      { :name => 'Kickstart default iPXE', :source => 'kickstart/iPXE.erb', :template_kind => kinds[:iPXE] },
+      { :name => 'Kickstart default user data', :source => 'kickstart/userdata.erb', :template_kind => kinds[:user_data] },
+      { :name => 'Preseed default', :source => 'preseed/provision.erb', :template_kind => kinds[:provision] },
+      { :name => 'Preseed default finish', :source => 'preseed/finish.erb', :template_kind => kinds[:finish] },
+      { :name => 'Preseed default PXELinux', :source => 'preseed/PXELinux.erb', :template_kind => kinds[:PXELinux] },
+      { :name => 'Preseed default iPXE', :source => 'preseed/iPXE.erb', :template_kind => kinds[:iPXE] },
+      { :name => 'Preseed default user data', :source => 'preseed/userdata.erb', :template_kind => kinds[:user_data] },
+      { :name => 'WAIK default PXELinux', :source => 'waik/PXELinux.erb', :template_kind => kinds[:PXELinux], :operatingsystems => os_windows },
+      { :name => "Junos default SLAX", :source => 'ztp/provision.erb', :template_kind => kinds[:provision], :operatingsystems => os_junos },
+      { :name => "Junos default ZTP config", :source => 'ztp/ZTP.erb', :template_kind => kinds[:ZTP], :operatingsystems => os_junos },
+      { :name => "Junos default finish", :source => 'ztp/finish.erb', :template_kind => kinds[:finish], :operatingsystems => os_junos },
+      # snippets
+      { :name => 'epel', :source => 'snippets/_epel.erb', :snippet => true },
+      { :name => 'fix_hosts', :source => 'snippets/_fix_hosts.erb', :snippet => true },
+      { :name => 'http_proxy', :source => 'snippets/_http_proxy.erb', :snippet => true },
+      { :name => 'puppet.conf', :source => 'snippets/_puppet.conf.erb', :snippet => true },
+      { :name => 'redhat_register', :source => 'snippets/_redhat_register.erb', :snippet => true }
+  ].each do |input|
+    next if ConfigTemplate.find_by_name(input[:name])
+    next if audit_modified? ConfigTemplate, input[:name]
+    t = ConfigTemplate.create({
+                                  :snippet  => false,
+                                  :template => File.read(File.join("#{Rails.root}/app/views/unattended", input.delete(:source)))
+                              }.merge(input))
+    raise "Unable to create template #{t.name}: #{format_errors t}" if t.nil? || t.errors.any?
+  end
+end
diff --git a/db/seeds.d/08-partition_tables.rb b/db/seeds.d/08-partition_tables.rb
new file mode 100644
index 000000000..9af750446
--- /dev/null
+++ b/db/seeds.d/08-partition_tables.rb
@@ -0,0 +1,21 @@
+# Partition tables
+Ptable.without_auditing do
+  [
+      { :name => 'AutoYaST entire SCSI disk', :os_family => 'Suse', :source => 'autoyast/disklayout_scsi.erb' },
+      { :name => 'AutoYaST entire virtual disk', :os_family => 'Suse', :source => 'autoyast/disklayout_virtual.erb' },
+      { :name => 'AutoYaST LVM', :os_family => 'Suse', :source => 'autoyast/disklayout_lvm.erb' },
+      { :name => 'Jumpstart default', :os_family => 'Solaris', :source => 'jumpstart/disklayout.erb' },
+      { :name => 'Jumpstart mirrored', :os_family => 'Solaris', :source => 'jumpstart/disklayout_mirrored.erb' },
+      { :name => 'Kickstart default', :os_family => 'Redhat', :source => 'kickstart/disklayout.erb' },
+      { :name => 'Preseed default', :os_family => 'Debian', :source => 'preseed/disklayout.erb' },
+      { :name => 'Preseed custom LVM', :os_family => 'Debian', :source => 'preseed/disklayout_lvm.erb' },
+      { :name => 'Junos default fake', :os_family => 'Junos', :source => 'ztp/disklayout.erb' }
+  ].each do |input|
+    next if Ptable.find_by_name(input[:name])
+    next if audit_modified? Ptable, input[:name]
+    p = Ptable.create({
+                          :layout => File.read(File.join("#{Rails.root}/app/views/unattended", input.delete(:source)))
+                      }.merge(input))
+    raise "Unable to create partition table: #{format_errors p}" if p.nil? || p.errors.any?
+  end
+end
diff --git a/db/seeds.d/10-installation_media.rb b/db/seeds.d/10-installation_media.rb
new file mode 100644
index 000000000..e88a40407
--- /dev/null
+++ b/db/seeds.d/10-installation_media.rb
@@ -0,0 +1,17 @@
+os_suse = Operatingsystem.find_all_by_type "Suse" || Operatingsystem.where("name LIKE ?", "suse")
+
+# Installation media: default mirrors
+Medium.without_auditing do
+  [
+      { :name => "CentOS mirror", :os_family => "Redhat", :path => "http://mirror.centos.org/centos/$major.$minor/os/$arch" },
+      { :name => "Debian mirror", :os_family => "Debian", :path => "http://ftp.debian.org/debian/" },
+      { :name => "Fedora mirror", :os_family => "Redhat", :path => "http://dl.fedoraproject.org/pub/fedora/linux/releases/$major/Fedora/$arch/os/" },
+      { :name => "OpenSUSE mirror", :os_family => "Suse", :path => "http://download.opensuse.org/distribution/$major.$minor/repo/oss", :operatingsystems => os_suse },
+      { :name => "Ubuntu mirror", :os_family => "Debian", :path => "http://archive.ubuntu.com/ubuntu/" }
+  ].each do |input|
+    next if Medium.where(['name = ? OR path = ?', input[:name], input[:path]]).any?
+    next if audit_modified? Medium, input[:name]
+    m = Medium.create input
+    raise "Unable to create medium: #{format_errors m}" if m.nil? || m.errors.any?
+  end
+end
diff --git a/db/seeds.d/11-smart_proxy_features.rb b/db/seeds.d/11-smart_proxy_features.rb
new file mode 100644
index 000000000..c80fb00ed
--- /dev/null
+++ b/db/seeds.d/11-smart_proxy_features.rb
@@ -0,0 +1,5 @@
+# Proxy features
+[ "TFTP", "DNS", "DHCP", "Puppet", "Puppet CA", "BMC", "Chef Proxy" ].each do |input|
+  f = Feature.find_or_create_by_name(input)
+  raise "Unable to create proxy feature: #{format_errors f}" if f.nil? || f.errors.any?
+end
diff --git a/db/seeds.d/12-auth_sources.rb b/db/seeds.d/12-auth_sources.rb
new file mode 100644
index 000000000..e049e1fed
--- /dev/null
+++ b/db/seeds.d/12-auth_sources.rb
@@ -0,0 +1,17 @@
+AuthSource.without_auditing do
+  # Auth sources
+  src = AuthSourceInternal.find_by_type "AuthSourceInternal"
+  src ||= AuthSourceInternal.create :name => "Internal"
+
+  # Users
+  unless User.find_by_login("admin").present?
+    User.without_auditing do
+      user = User.new(:login => "admin", :firstname => "Admin", :lastname => "User", :mail => Setting[:administrator])
+      user.admin = true
+      user.auth_source = src
+      user.password = "changeme"
+      User.current = user
+      raise "Unable to create admin user: #{format_errors user}" unless user.save
+    end
+  end
+end
diff --git a/db/seeds.d/13-compute_profiles.rb b/db/seeds.d/13-compute_profiles.rb
new file mode 100644
index 000000000..18206e361
--- /dev/null
+++ b/db/seeds.d/13-compute_profiles.rb
@@ -0,0 +1,13 @@
+# Compute Profiles - only create if there are not any
+if ComputeProfile.unconfigured?
+  ComputeProfile.without_auditing do
+    [
+        { :name => '1-Small' },
+        { :name => '2-Medium' },
+        { :name => '3-Large' },
+    ].each do |input|
+      cp = ComputeProfile.create input
+      raise "Unable to create hardware profile: #{format_errors m}" if cp.nil? || cp.errors.any?
+    end
+  end
+end
diff --git a/db/seeds.d/15-bookmarks.rb b/db/seeds.d/15-bookmarks.rb
new file mode 100644
index 000000000..5acadcadb
--- /dev/null
+++ b/db/seeds.d/15-bookmarks.rb
@@ -0,0 +1,16 @@
+# Bookmarks
+Bookmark.without_auditing do
+  [
+      { :name => "eventful", :query => "eventful = true", :controller=> "reports" },
+      { :name => "active", :query => 'last_report > "35 minutes ago" and (status.applied > 0 or status.restarted > 0)', :controller=> "hosts" },
+      { :name => "out of sync", :query => 'last_report < "30 minutes ago" andstatus.enabled = true', :controller=> "hosts" },
+      { :name => "error", :query => 'last_report > "35 minutes ago" and (status.failed > 0 or status.failed_restarts > 0 or status.skipped > 0)', :controller=> "hosts" },
+      { :name => "disabled", :query => 'status.enabled = false', :controller=> "hosts" },
+      { :name => "ok hosts", :query => 'last_report > "35 minutes ago" and status.enabled = true and status.applied = 0 and status.failed = 0 and status.pending = 0', :controller=> "hosts" }
+  ].each do |input|
+    next if Bookmark.find_by_name(input[:name])
+    next if audit_modified? Bookmark, input[:name]
+    b = Bookmark.create({ :public => true }.merge(input))
+    raise "Unable to create bookmark: #{format_errors b}" if b.nil? || b.errors.any?
+  end
+end
diff --git a/db/seeds.d/20-permissions.rb b/db/seeds.d/20-permissions.rb
new file mode 100644
index 000000000..44713490a
--- /dev/null
+++ b/db/seeds.d/20-permissions.rb
@@ -0,0 +1,152 @@
+permissions = [
+    ['Architecture', 'view_architectures'],
+    ['Architecture', 'create_architectures'],
+    ['Architecture', 'edit_architectures'],
+    ['Architecture', 'destroy_architectures'],
+    ['Audit', 'view_audit_logs'],
+    ['AuthSourceLdap', 'view_authenticators'],
+    ['AuthSourceLdap', 'create_authenticators'],
+    ['AuthSourceLdap', 'edit_authenticators'],
+    ['AuthSourceLdap', 'destroy_authenticators'],
+    ['Bookmark', 'view_bookmarks'],
+    ['Bookmark', 'create_bookmarks'],
+    ['Bookmark', 'edit_bookmarks'],
+    ['Bookmark', 'destroy_bookmarks'],
+    ['ComputeProfile', 'view_compute_profiles'],
+    ['ComputeProfile', 'create_compute_profiles'],
+    ['ComputeProfile', 'edit_compute_profiles'],
+    ['ComputeProfile', 'destroy_compute_profiles'],
+    ['ComputeResource', 'view_compute_resources'],
+    ['ComputeResource', 'create_compute_resources'],
+    ['ComputeResource', 'edit_compute_resources'],
+    ['ComputeResource', 'destroy_compute_resources'],
+    ['ComputeResource', 'view_compute_resources_vms'],
+    ['ComputeResource', 'create_compute_resources_vms'],
+    ['ComputeResource', 'edit_compute_resources_vms'],
+    ['ComputeResource', 'destroy_compute_resources_vms'],
+    ['ComputeResource', 'power_compute_resources_vms'],
+    ['ComputeResource', 'console_compute_resources_vms'],
+    ['ConfigTemplate', 'view_templates'],
+    ['ConfigTemplate', 'create_templates'],
+    ['ConfigTemplate', 'edit_templates'],
+    ['ConfigTemplate', 'destroy_templates'],
+    ['ConfigTemplate', 'deploy_templates'],
+    [nil, 'access_dashboard'],
+    ['Domain', 'view_domains'],
+    ['Domain', 'create_domains'],
+    ['Domain', 'edit_domains'],
+    ['Domain', 'destroy_domains'],
+    ['Environment', 'view_environments'],
+    ['Environment', 'create_environments'],
+    ['Environment', 'edit_environments'],
+    ['Environment', 'destroy_environments'],
+    ['Environment', 'import_environments'],
+    ['LookupKey', 'view_external_variables'],
+    ['LookupKey', 'create_external_variables'],
+    ['LookupKey', 'edit_external_variables'],
+    ['LookupKey', 'destroy_external_variables'],
+    ['FactValue', 'view_facts'],
+    ['FactValue', 'upload_facts'],
+    ['Filter', 'view_filters'],
+    ['Filter', 'create_filters'],
+    ['Filter', 'edit_filters'],
+    ['Filter', 'destroy_filters'],
+    ['CommonParameter', 'view_globals'],
+    ['CommonParameter', 'create_globals'],
+    ['CommonParameter', 'edit_globals'],
+    ['CommonParameter', 'destroy_globals'],
+    ['HostClass', 'edit_classes'],
+    ['Parameter', 'create_params'],
+    ['Parameter', 'edit_params'],
+    ['Parameter', 'destroy_params'],
+    ['Hostgroup', 'view_hostgroups'],
+    ['Hostgroup', 'create_hostgroups'],
+    ['Hostgroup', 'edit_hostgroups'],
+    ['Hostgroup', 'destroy_hostgroups'],
+    ['Host', 'view_hosts'],
+    ['Host', 'create_hosts'],
+    ['Host', 'edit_hosts'],
+    ['Host', 'destroy_hosts'],
+    ['Host', 'build_hosts'],
+    ['Host', 'power_hosts'],
+    ['Host', 'console_hosts'],
+    ['Host', 'ipmi_boot'],
+    ['Host', 'puppetrun_hosts'],
+    ['Image', 'view_images'],
+    ['Image', 'create_images'],
+    ['Image', 'edit_images'],
+    ['Image', 'destroy_images'],
+    ['Location', 'view_locations'],
+    ['Location', 'create_locations'],
+    ['Location', 'edit_locations'],
+    ['Location', 'destroy_locations'],
+    ['Location', 'assign_locations'],
+    ['Medium', 'view_media'],
+    ['Medium', 'create_media'],
+    ['Medium', 'edit_media'],
+    ['Medium', 'destroy_media'],
+    ['Model', 'view_models'],
+    ['Model', 'create_models'],
+    ['Model', 'edit_models'],
+    ['Model', 'destroy_models'],
+    ['Operatingsystem', 'view_operatingsystems'],
+    ['Operatingsystem', 'create_operatingsystems'],
+    ['Operatingsystem', 'edit_operatingsystems'],
+    ['Operatingsystem', 'destroy_operatingsystems'],
+    ['Organization', 'view_organizations'],
+    ['Organization', 'create_organizations'],
+    ['Organization', 'edit_organizations'],
+    ['Organization', 'destroy_organizations'],
+    ['Organization', 'assign_organizations'],
+    ['Ptable', 'view_ptables'],
+    ['Ptable', 'create_ptables'],
+    ['Ptable', 'edit_ptables'],
+    ['Ptable', 'destroy_ptables'],
+    [nil, 'view_plugins'],
+    ['Puppetclass', 'view_puppetclasses'],
+    ['Puppetclass', 'create_puppetclasses'],
+    ['Puppetclass', 'edit_puppetclasses'],
+    ['Puppetclass', 'destroy_puppetclasses'],
+    ['Puppetclass', 'import_puppetclasses'],
+    ['Report', 'view_reports'],
+    ['Report', 'destroy_reports'],
+    ['Report', 'upload_reports'],
+    ['Role', 'view_roles'],
+    ['Role', 'create_roles'],
+    ['Role', 'edit_roles'],
+    ['Role', 'destroy_roles'],
+    [nil, 'access_settings'],
+    ['SmartProxy', 'view_smart_proxies'],
+    ['SmartProxy', 'create_smart_proxies'],
+    ['SmartProxy', 'edit_smart_proxies'],
+    ['SmartProxy', 'destroy_smart_proxies'],
+    ['SmartProxy', 'view_smart_proxies_autosign'],
+    ['SmartProxy', 'create_smart_proxies_autosign'],
+    ['SmartProxy', 'destroy_smart_proxies_autosign'],
+    ['SmartProxy', 'view_smart_proxies_puppetca'],
+    ['SmartProxy', 'edit_smart_proxies_puppetca'],
+    ['SmartProxy', 'destroy_smart_proxies_puppetca'],
+    [nil, 'view_statistics'],
+    ['Subnet', 'view_subnets'],
+    ['Subnet', 'create_subnets'],
+    ['Subnet', 'edit_subnets'],
+    ['Subnet', 'destroy_subnets'],
+    ['Subnet', 'import_subnets'],
+    [nil, 'view_tasks'],
+    ['Trend', 'view_trends'],
+    ['Trend', 'create_trends'],
+    ['Trend', 'edit_trends'],
+    ['Trend', 'destroy_trends'],
+    ['Trend', 'update_trends'],
+    ['Usergroup', 'view_usergroups'],
+    ['Usergroup', 'create_usergroups'],
+    ['Usergroup', 'edit_usergroups'],
+    ['Usergroup', 'destroy_usergroups'],
+    ['User', 'view_users'],
+    ['User', 'create_users'],
+    ['User', 'edit_users'],
+    ['User', 'destroy_users'],
+]
+permissions.each do |resource, permission|
+  Permission.find_or_create_by_resource_type_and_name resource, permission
+end
